.NOLIST
include HL_LIDA.inc
.code

;#########################################################################
;		Common AddIn Procedures
align	4
DllEntry proc hinstDLL:DWORD,fdwReason:DWORD,pvReserved:DWORD
	mov		eax,	[fdwReason]
	.if eax == DLL_PROCESS_ATTACH
		m2m [hInstance],[hinstDLL]
	.endif
	mov eax,TRUE
	ret
DllEntry Endp

; The addin initalization proc
; Return hooks in eax:=<0>,edx:=<0>,ecx:=<0>
; fOpt is a value read from ini and passed to the dll
; Use for option settings
InstallDll proc EXPORT USES EBX hWin:DWORD,fOpt:DWORD
	xor		eax,	eax
	mov		[OldEditProc1],	eax
	mov		[OldEditProc2],	eax
	mov		[hEdt1],	eax
	mov		[hEdt2],	eax

	mov	ebx,	[hWin]
	mov [pAddinHandles],AddInMsg(ebx,AIM_GETHANDLES)	; Get pointer to handles struct
	mov		edx,	[eax].ADDINHANDLES.hStatus
	mov		[hStatB],	edx

	mov [pAddinProcs],	AddInMsg(ebx,AIM_GETPROCS)		; Get pointer to proc struct
	mov [pAddinData],	AddInMsg(ebx,AIM_GETDATA)		; Get pointer to data struct

	; If Option [fOption] == 0 then exit
	mov eax,		[fOpt]
	mov		[fOptions],	eax
	xor		eax,		eax
	test	[fOptions],	O_EN
	.if !ZERO?
		;Hook into AIM_TIMER
		; Allocate a new menu id
		mov [IDAddIn],	AddInMsg(ebx,AIM_GETMENUID)		; Get MENUID
		; Tell RadASM messages we want to hook
		mov eax, AddInHook(AIM_EDITSELCHANGE,AIM_CLOSE,AIM_MDIACTIVATE)
	.endif
		or	eax, AddInHook(AIM_COMMAND); or -1 and NOT RAM_TIMER
	;Note!
	;Also set ecx and edx to NULL in case more than 32 hooks are
	;needed in the future.
	mov		ecx,AddInHook(RAM_UNHOOK,RAM_ADDINSLOADED)

	xor		edx,	edx
	ret

InstallDll Endp

align	4
; Export this proc (it is autoexported if MakeDef is enabled with option 2)
; This proc handles messages sent from RadASM to our dll
; Return TRUE to prevent RadASM and other dll's from
; processing command.
DllProc proc EXPORT hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other dll's from  processing command.
LOCAL	TR		:TEXTRANGE
LOCAL	rect	:RECT
LOCAL	CR		:CHARRANGE
LOCAL	RetVal	:DWORD
	mov	[RetVal],	TRUE

	mov	eax, [uMsg]
	.if eax == AIM_COMMAND
		mov eax,[wParam]
		movzx edx,ax
		shr eax, 16
		.IF edx == [IDAddIn] && eax == BN_CLICKED
			; Your addin has been selected
		.ENDIF

	.elseif eax==AIM_UNHOOK
		mov		eax,[hWin]
		mov		ecx,[wParam]
		mov		edx,[lParam]
		.if eax==[hEdt1] && ecx==[OldEditProc1]
			;Remove the hook from the chain
			mov		[OldEditProc1],edx
			mov		eax,TRUE
			jmp		Ex
		.elseif eax==[hEdt2] && ecx==[OldEditProc2]
			;Remove the hook from the chain
			mov		[OldEditProc2],edx
			mov		eax,TRUE
			jmp		Ex
		.endif

	.elseif eax==AIM_CLOSE
		;Undo subclassing
		.if [OldEditProc1]
			invoke UnHook,[hEdt1],offset RAEditProc,[OldEditProc1]
			mov		[OldEditProc1],0
		.endif
		.if [OldEditProc2]
			invoke UnHook,[hEdt2],offset RAEditProc,[OldEditProc2]
			mov		[OldEditProc2],0
		.endif
		mov edx,[pAddinHandles]
		invoke DeleteMenu,[edx].ADDINHANDLES.hMenu,[IDAddIn],MF_BYCOMMAND
		xor		eax,		eax
		mov		[IDAddIn],	eax
;		inc		eax
;		mov		[fNeedHook],eax

	.elseif eax==AIM_MDIACTIVATE
		;A new mdi window is selected
		;Message received by MDI child
		;hwndChildDeact = (HWND) wParam;        // child being deactivated
		;hwndChildAct = (HWND) lParam;          // child being activated
		;						Parameters
		;In messages sent to an MDI client window:
		;hwndChildAct
		;	Value of wParam. Identifies the MDI child window to be activated.
		;
		;In messages received by an MDI child window:
		;hwndChildDeact
		;	Value of wParam. Identifies the MDI child window being deactivated.
		;hwndChildAct
		;	Value of lParam. Identifies the MDI child window being activated.
		
		.if [hWin]
			invoke GetWindowLong,[hWin],DWL_MSGRESULT	;Get editor type ; the return value of a message processed in the dialog box procedure.
			.if eax==ID_EDIT
				mov		eax,[wParam]
				.if eax==[hWin]
					.if [OldEditProc1]
						;Unsubclass the RAEdit windows
						invoke UnHook,[hEdt1],offset RAEditProc,[OldEditProc1]
						invoke UnHook,[hEdt2],offset RAEditProc,[OldEditProc2]
						xor eax, eax
						mov [OldEditProc1],eax				;Set as unhooked
						mov [OldEditProc2],eax				;Set as unhooked
					.endif
				.else

				;Subclass the RAEdit child windows
				invoke GetWindowLong,[lParam],GWL_USERDATA
				invoke GetWindowLong,eax,DWL_MSGRESULT	;the return value of a message processed in the dialog box procedure.
				mov		[lpEDIT_struct],	eax
				mov		edx,	[eax].EDIT.edta.hwnd
				mov		[hEdt1],edx
				mov		edx,	[eax].EDIT.edtb.hwnd
				mov		[hEdt2],edx
				;=======================================================
				; Check the richedit version
				;=======================================================
				invoke SendMessage,[hEdt1],EM_SETTYPOGRAPHYOPTIONS,TO_SIMPLELINEBREAK,TO_SIMPLELINEBREAK
				invoke SendMessage,[hEdt1],EM_GETTYPOGRAPHYOPTIONS,1,1
				.if eax==0		; means this message is not processed
					mov [RichEditVersion],2
				.else
					mov [RichEditVersion],3
					;=============================================================================
					; Make it emulate system edit control so the text color update doesn't  take very long
					;=============================================================================
					invoke SendMessage,[hEdt1],EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
					invoke SendMessage,[hEdt2],EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
				.endif

				;Subclass the RAEdit child windows
				invoke SetWindowLong,[hEdt1],GWL_WNDPROC,ADDR RAEditProc
				mov [OldEditProc1],eax
				invoke SetWindowLong,[hEdt2],GWL_WNDPROC,ADDR RAEditProc
				mov [OldEditProc2],eax
				mov		eax, TRUE
				jmp		Ex

				.endif
			.endif
		.endif
;	;
;
	.elseif	eax==AIM_EDITSELCHANGE
;		;Always return FALSE
;		;hWin		handle of mdi child window
;		;wParam		handle of RicEdit
;		;lParam		ID_EDIT or ID_EDITTXT

		invoke	SendMessage,[wParam],EM_EXGETSEL,NULL,ADDR CR
		mov		edx,		[CR.cpMin]
		mov		[vBeginSel],	edx
		mov		ecx,		[CR.cpMax]

		sub		ecx,		edx
		mov		[sizeHL],	ecx

		.if	ecx<sizeof szHL
			invoke	SendMessage,[wParam],EM_GETSELTEXT,NULL,ADDR szHL
			lea		edx,		[szHL]
			xor		eax,		eax
			mov		ecx,		[sizeHL]
			.while	ecx
				mov	al,	[edx+ecx-1]
				.if	al==10 || al==13 || al==' ' || al==09
					mov	[sizeHL],	0
				.endif
				dec	al
				and	al,	NOT(01fh)
				or	ah,	al
				dec	ecx
			.endw
			.if	!ah
				mov	[sizeHL],	eax
			.endif
			invoke SendMessage,[wParam],REM_REPAINT,1,0
		.else
			xor		eax,	eax
			mov		[sizeHL],	eax
		.endif
		return	TRUE
	.elseif	eax==AIM_ADDINSLOADED
;		.if	[fNeedHook]==1
;			mov		[fNeedHook],0
;			invoke	TextOutput,$TA0('\n\nINFO: Please reopen file.\n\n')
;		.endif
	.endif
	xor		eax,	eax
  Ex:
	ret
DllProc Endp

align	4
;#########################################################################
GetOptions proc
	mov		eax,offset AddinOpt
	ret
GetOptions endp
align	4

UnHook proc hWin:HWND,lpThisProc:DWORD,lpOldProc:DWORD

	invoke GetWindowLong,[hWin],GWL_WNDPROC
	.if eax==[lpThisProc]
		;Last in chain, just unhook
		invoke SetWindowLong,[hWin],GWL_WNDPROC,[lpOldProc]
	.else
		;Let the next in the chain unhook me
		push	RAM_UNHOOK
		push	[lpOldProc]
		push	[lpThisProc]
		push	AIM_UNHOOK
		push	[hWin]
		mov		eax,[pAddinProcs]
		call	[eax].ADDINPROCS.lpDllProc
	.endif
	ret

UnHook endp

align	4
RAEditProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD,lParam:DWORD
;	LOCAL txtrange:TEXTRANGE
;	LOCAL RealRect:RECT
	LOCAL rect:RECT
;	LOCAL FirstChar:DWORD
;	LOCAL hOldFont:DWORD
;	LOCAL hOldRgn:DWORD
;	LOCAL hREdit:DWORD
;	LOCAL hRgn:DWORD
;	LOCAL hdc:DWORD
;	LOCAL cnt:DWORD
;	LOCAL W:DWORD
;	LOCAL OLDedi:DWORD
;	LOCAL OLDesi:DWORD
	.if uMsg==WM_PAINT
		mov	[OLDedi], edi
		mov	[OLDesi], esi

		mov eax,	[pAddinHandles]
		mov	eax,	[eax].ADDINHANDLES.hEdit
		mov	[hREdit],eax

		invoke HideCaret,[hWnd]

		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
		push eax
;##\		
		invoke	SendMessage,[hStatB],SB_GETPARTS,6,ADDR vSBA
;jmp	skip		

		.if [sizeHL]
			invoke GetDC,[hWnd]
			mov [hdc],eax

			mov		eax,	[pAddinHandles]
			invoke SelectObject,[hdc],[eax].ADDINHANDLES.hFont
			mov		[hOldFont],eax

			invoke SetBkMode,[hdc],OPAQUE

			invoke SetTextColor,[hdc],1
			invoke SetBkColor,[hdc], 00FFFFFFh

			test	[fOptions],O_BB
			.if	!ZERO?
				invoke SetTextColor,[hdc],1
				invoke SetBkColor,[hdc], 00FF0000h
			.endif

			test	[fOptions],O_BG
			.if	!ZERO?
				invoke SetTextColor,[hdc],1
				invoke SetBkColor,[hdc], 0000FF00h
			.endif

			test	[fOptions],O_BR
			.if	!ZERO?
				invoke SetTextColor,[hdc],1
				invoke SetBkColor,[hdc], 000000FFh
			.endif

			;===================================================================
			; Do syntax hiliting here!
			;===================================================================
			invoke SendMessage,[hREdit],EM_GETRECT,0,addr rect
			
			invoke SendMessage,[hREdit],EM_CHARFROMPOS,0,ADDR rect.left
			;========================================================
			; obtain the line number
			;========================================================
			invoke SendMessage,[hREdit],EM_LINEFROMCHAR,eax,0
			invoke SendMessage,[hREdit],EM_LINEINDEX,eax,0
			mov		[txtrange.chrg.cpMin],eax
			mov		[FirstChar],eax
	;
			invoke SendMessage,[hREdit],EM_CHARFROMPOS,0,addr rect.right
			mov		[txtrange.chrg.cpMax],eax

			sub		eax,	[FirstChar]
			.if eax < sizeof buffer
				push	[rect.left]
				pop		[RealRect.left]
				push	[rect.top]
				pop		[RealRect.top]
				push	[rect.right]
				pop		[RealRect.right]
				push	[rect.bottom]
				pop		[RealRect.bottom]
				invoke CreateRectRgn,[RealRect.left],[RealRect.top],[RealRect.right],[RealRect.bottom]
				mov		[hRgn],eax
				invoke SelectObject,[hdc],[hRgn]
				mov		[hOldRgn],eax
	
				;< Get the visible text into buffer
				lea		eax,[buffer]
				mov		[txtrange.lpstrText],eax
				invoke SendMessage,[hREdit],EM_GETTEXTRANGE,0,ADDR txtrange
				mov edx,eax		; edx == size of the text
				;>
				lea		eax,	[buffer]
				mov		edi,	eax	; 
	
				mov		[cnt],	0
	;			xor		eax,	eax
				.while edx>0
					push	edx
				
					mov		ecx,	[sizeHL]
					xor		eax,eax
					.while	ecx
						xor		al,	[edi+ecx-1]
						xor		al,	[szHL+ecx-1]
						or		ah,	al
						dec		ecx
					.endw
	
					.if	ah==0
						inc	[cnt]	;Increment counter
	
						mov ecx,edi
						lea edx,[buffer]
						sub ecx,edx
						add ecx,[FirstChar]
	
						push	ecx
	
						add	ecx,	[sizeHL]
						
						push	edi
						mov		edi,	[OLDedi]
						invoke SendMessage,[hREdit],EM_POSFROMCHAR,addr rect,ecx
						pop		edi
						
						mov		eax,	[rect.left]
						mov		[W],		eax
	
						mov ecx,edi
						lea edx,[buffer]
						sub ecx,edx
						add ecx,[FirstChar]
	
						push	edi
						mov	edi,	[OLDedi]
						invoke SendMessage,[hREdit],EM_POSFROMCHAR,addr rect,ecx
						pop	edi
						
						mov		eax,	[rect.left]
						sub		[W],		eax
						pop	ecx
						.if	ecx==[vBeginSel]
							invoke GetTextColor,[hdc]
							push	eax
							invoke GetBkColor,[hdc]
							push	eax
	
							invoke SetBkColor,[hdc],00C8E01Fh
							invoke SetTextColor,[hdc],00000000h
								invoke DrawText,[hdc],ADDR szHL,[sizeHL],ADDR rect,DT_MODIFYSTRING
							pop		eax
							invoke SetBkColor,[hdc],eax
							pop		eax
							invoke SetTextColor,[hdc],eax
						.else
							invoke DrawText,[hdc],ADDR szHL,[sizeHL],ADDR rect,DT_MODIFYSTRING
						.endif
						add	edi,[sizeHL]
					.else
						inc edi
					.endif
					pop		edx
					dec edx
				.endw
	;
				invoke SelectObject,[hdc],[hOldFont]
	
				invoke SelectObject,[hdc],[hOldRgn]
				invoke DeleteObject,[hRgn]
	
				invoke ReleaseDC,[hWnd],[hdc]
	
				;<
				invoke GetWindowRect,[hStatB],ADDR rect
				mov		eax,	[rect.right]
				sub		eax,	[rect.left]
				sub		eax,	200
	
				mov		ecx,	[vSBA+4*2]
				add		ecx,	200
				.if		ecx>eax
					mov		eax,	ecx
				.endif
				mov		[vSBA+4*3],eax
	
				mov		DWORD ptr [vSBA+4*4],-1
				invoke	SendMessage,[hStatB],SB_SETPARTS,5,ADDR vSBA
				invoke	dwtoa,[cnt],ADDR vSBA
				invoke	SendMessage,[hStatB],SB_SETTEXT,4,ADDR szOnPage
				;>
			.endif
			
		.else
			mov		DWORD ptr [vSBA+4*3],-1
			invoke	SendMessage,[hStatB],SB_SETPARTS,4,ADDR vSBA
		.endif

		invoke ShowCaret,[hWnd]
;##/		
skip:
		pop eax
		mov	edi,	[OLDedi]
		mov	esi,	[OLDesi]
	.elseif [uMsg]==WM_CLOSE
		invoke SetWindowLong,[hWnd],GWL_WNDPROC,[OldEditProc1]
		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
	.else
		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
	.endif
	ret
RAEditProc endp
End DllEntry


1000cf31  push ebp
1000cf32  mov ebp,esp
1000cf34  add esp,-4
1000cf37  push ebx
1000cf38  push esi
1000cf39  push edi
1000cf3a  mov dword ptr ss:[ebp-4],0
1000cf41  mov ebx,dword ptr ss:[ebp+8]
1000cf44  mov eax,dword ptr ss:[ebp+c]
1000cf47  mov edx,dword ptr ss:[ebp+10]
1000cf4a  mov edi,dword ptr ss:[ebp+14]
1000cf4d  cmp eax,edx
1000cf4f  jbe short raedit.1000cf52
1000cf51  xchg eax,edx
1000cf52  mov dword ptr ss:[ebp+c],eax
1000cf55  mov dword ptr ss:[ebp+10],edx
1000cf58  push dword ptr ss:[ebp+10]
1000cf5b  push ebx
1000cf5c  call raedit.1000187f
1000cf61  mov dword ptr ss:[ebp+10],ecx
1000cf64  push dword ptr ss:[ebp+c]
1000cf67  push ebx
1000cf68  call raedit.1000187f
1000cf6d  mov dword ptr ss:[ebp+c],ecx
1000cf70  mov ecx,eax
1000cf72  mov edx,dword ptr ss:[ebp+c]
1000cf75  mov esi,dword ptr ds:[ebx+b0]
1000cf7b  add esi,dword ptr ds:[ebx+b8]
1000cf81  jmp short raedit.1000cfb9
1000cf83  mov eax,dword ptr ds:[ebx+c0]
1000cf89  add eax,dword ptr ds:[esi]
1000cf8b  push eax
1000cf8c  mov al,byte ptr ds:[ecx+eax+14]
1000cf90  inc ecx
1000cf91  or edi,edi
1000cf93  je short raedit.1000cf98
1000cf95  mov byte ptr ds:[edi],al                      ;<===  
1000cf97  inc edi
1000cf98  cmp dword ptr ss:[ebp+18],0
1000cf9c  je short raedit.1000cfae
1000cf9e  cmp al,0d
1000cfa0  jnz short raedit.1000cfae
1000cfa2  or edi,edi
1000cfa4  je short raedit.1000cfab
1000cfa6  mov al,0a
1000cfa8  mov byte ptr ds:[edi],al
1000cfaa  inc edi
1000cfab  inc dword ptr ss:[ebp-4]
1000cfae  pop eax
1000cfaf  cmp ecx,dword ptr ds:[eax]
1000cfb1  jnz short raedit.1000cfb8
1000cfb3  xor ecx,ecx
1000cfb5  add esi,4
1000cfb8  inc edx
1000cfb9  cmp edx,dword ptr ss:[ebp+10]
1000cfbc  jb short raedit.1000cf83
1000cfbe  or edi,edi
1000cfc0  je short raedit.1000cfc5
1000cfc2  mov byte ptr ds:[edi],0
1000cfc5  mov eax,dword ptr ss:[ebp+10]
1000cfc8  sub eax,dword ptr ss:[ebp+c]
1000cfcb  pop edi
1000cfcc  pop esi
1000cfcd  pop ebx
1000cfce  leave
1000cfcf  retn 14
; S_Alex
